Skip to main content
`Ctrl`+`K`

# SNESFunctionType

Type of function computed

## Synopsis

    typedef enum {
      SNES_FUNCTION_DEFAULT          = -1,
      SNES_FUNCTION_UNPRECONDITIONED = 0,
      SNES_FUNCTION_PRECONDITIONED   = 1
    } SNESFunctionType;

## Values

- `SNES_FUNCTION_DEFAULT` - the default behavior for the current `SNESType`

- `SNES_FUNCTION_UNPRECONDITIONED` - the original function provided

- `SNES_FUNCTION_PRECONDITIONED` - the modification of the function by the preconditioner

## Note

Support for these is dependent on the solver.

## See Also

SNES: Nonlinear Solvers, `SNES`, `SNESSolve()`, `SNESGetConvergedReason()`, `KSPSetNormType()`, `KSPSetConvergenceTest()`, `KSPSetPCSide()`

## Level

advanced

## Location

include/petscsnes.h

Index of all SNES routines
Table of Contents for all manual pages
Index of all manual pages